
Ruby - Feature #19776

Warn bundled gems when it called from `require`

07/19/2023 09:02 AM - hsbt (Hiroshi SHIBATA)

Status: Closed   

Priority: Normal   

Assignee: hsbt (Hiroshi SHIBATA)   

Target version:    

Description

We should warn when users try to load default gems that will be promoted bundled gems at next version. We will warn them only

under the bundler environment without Gemfile.

Ruby 3.3:

Warn for adding bundled gems to be addressed Ruby 3.4 to Gemfile when user load its gem without gem 'foo' in their

Gemfile.

Target libraries are TBD

Also warn existing bundled gems was loaded without gem 'foo' of Gemfile. Ex. net-smtp, rexml etc.

Ruby 3.4:

Promote bundled gems.

Raise LoadError same as current behavior with warnings of Ruby 3.3.

Warn same as Ruby 3.3.

I implemented PoC for this: https://github.com/ruby/ruby/pull/8096

Related issues:

Related to Ruby - Feature #19351: Promote bundled gems at Ruby 3.3 Closed

Related to Ruby - Feature #19843: Promote bigdecimal as bundled gems at Ruby 3.4 Closed

Related to Ruby - Bug #19885: Invalid Warning for Default Gems That Will Move... Closed

History

#1 - 07/19/2023 09:03 AM - hsbt (Hiroshi SHIBATA)

- Related to Feature #19351: Promote bundled gems at Ruby 3.3 added

#2 - 07/20/2023 07:27 AM - vo.x (Vit Ondruch)

Isn't it time that upstream should start to encourage that every part of the StdLib should be listed in Gemfile? How long it is the URI gem fixing

MEDIUM rated CVE was released and who uses it? Who added it into their Gemfile? Who even noticed that there is some vulnerability to fix?

Really, the current practice "it is part of StdLib, therefore I don't list it anywhere among dependencies" should be discouraged. The PR should actually

be updated to warn when any part of StdLib is loaded without being listed as a dependency in either Gemfile or transitively via different gem.

#3 - 07/21/2023 04:22 AM - hsbt (Hiroshi SHIBATA)

I submit https://github.com/rubygems/rubygems/pull/6831 to RubyGems upstream.

#4 - 08/17/2023 09:58 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Assigned to Closed

#5 - 08/22/2023 03:10 AM - hsbt (Hiroshi SHIBATA)

- Related to Feature #19843: Promote bigdecimal as bundled gems at Ruby 3.4 added

#6 - 08/24/2023 09:00 AM - hsbt (Hiroshi SHIBATA)

- Tracker changed from Bug to Feature

- Backport deleted (3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN)

#7 - 09/22/2023 10:05 AM - Eregon (Benoit Daloze)

- Related to Bug #19885: Invalid Warning for Default Gems That Will Move to Bundled Gems added
